"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));

var i18n = _interopRequireWildcard(require("embark-i18n"));

var _embarkCore = require("embark-core");

var _blockchain = require("./blockchain");

const constants = require('embark-core/constants');

let blockchainProcess;

class BlockchainProcess extends _embarkCore.ProcessWrapper {
  constructor(options) {
    var _context, _context2;

    super();
    this.blockchainConfig = options.blockchainConfig;
    this.client = options.client;
    this.env = options.env;
    this.isDev = options.isDev;
    this.certOptions = options.certOptions;
    i18n.setOrDetectLocale(options.locale);
    this.blockchainConfig.silent = true;
    this.blockchain = new _blockchain.BlockchainClient(this.blockchainConfig, {
      clientName: this.client,
      env: this.env,
      certOptions: this.certOptions,
      onReadyCallback: (0, _bind.default)(_context = this.blockchainReady).call(_context, this),
      onExitCallback: (0, _bind.default)(_context2 = this.blockchainExit).call(_context2, this),
      logger: console
    });
    this.blockchain.run();
  }

  blockchainReady() {
    blockchainProcess.send({
      result: constants.blockchain.blockchainReady
    });
  }

  blockchainExit() {
    // tell our parent process that ethereum client has exited
    blockchainProcess.send({
      result: constants.blockchain.blockchainExit
    });
  }

  kill() {
    this.blockchain.kill();
  }

}

process.on('message', msg => {
  if (msg === 'exit') {
    return blockchainProcess.kill();
  }

  if (msg.action === constants.blockchain.init) {
    blockchainProcess = new BlockchainProcess(msg.options);
    return blockchainProcess.send({
      result: constants.blockchain.initiated
    });
  }
});
//# sourceMappingURL=blockchainProcess.js.map